﻿#Region "FileHeader"
#If False Then
#End If
'-- Options, Imports
#End Region 'FileHeader

Imports System.Runtime.CompilerServices

Namespace System.Collections.Generic

   Public Module CollectionX

      Public Delegate Function GetChilds(Of T)(item As T) As IEnumerable
      Private _Rnc As New Random

#Region "ICollection(mit und ohne T)"

      <Extension()> _
      Public Function ToArray(Of T)(items As System.Collections.ICollection) As T()
         ReDim ToArray(items.Count - 1)
         If items.Count > 0 Then items.CopyTo(ToArray, 0)
      End Function

#End Region 'ICollection(ohne T)

#Region "Array"
      ''' <summary>gibt den **typisierten** Enumerator des Arrays zurück</summary>
      <Extension(), DebuggerStepThrough()> _
      Public Function GetEnumeratorX(Of T)(items As T()) As IEnumerator(Of T)
         Return DirectCast(items, IList(Of T)).GetEnumerator
      End Function

      ''' <summary> erstellt ein neues Array, und kopiert den angegebenen Bereich hinein </summary>
      <Extension()> _
      Public Function Take(Of T)(items As T(), start As Integer, count As Integer) As T()
         count = Math.Min(items.Length - start, count)
         ReDim Take(count - 1)
         Array.Copy(items, start, Take, 0, count)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function FindIndex(Of T)(Arr() As T, IsMatch As Predicate(Of T)) As Integer
         Return Array.FindIndex(Arr, IsMatch)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function Find(Of T)(Arr() As T, IsMatch As Predicate(Of T)) As T
         Return Array.Find(Arr, IsMatch)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function IndexOf(Of T)(Arr() As T, Element As T) As Integer
         Return Array.IndexOf(Arr, Element)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function Contains(Of T)(Arr() As T, Element As T) As Boolean
         Return DirectCast(Arr, IList(Of T)).Contains(Element)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function ToArray(Of TSrc, TDest)(Arr() As TSrc, Converter As Converter(Of TSrc, TDest)) As TDest()
         Return Array.ConvertAll(Arr, Converter)
      End Function

#If True Then
#ElseIf True Then
      <Extension()> _
      Public Function SelectManyX(Of T)(items As T()()) As IEnumerable(Of T)
         Return Linq.Enumerable.SelectMany(items, Function(itm) itm)
      End Function
      <Extension()> _
      Public Function SelectMany(Of T)(items As IEnumerable(Of T())) As IEnumerable(Of T)
         Return Linq.Enumerable.SelectMany(items, Function(itm) itm)
      End Function

#ElseIf True Then
#End If

      <Extension(), DebuggerStepThrough(), Obsolete("use Array.ToArray-Extension")> _
      Public Function ConvertAll(Of TSrc, TDest)( _
              Arr() As TSrc, Converter As Converter(Of TSrc, TDest)) As TDest()
         Return Array.ConvertAll(Arr, Converter)
      End Function
      <Extension(), DebuggerStepThrough(), Obsolete("use Array.ToArray-Extension")> _
      Public Function ConvertAll(Of TSrc, TDest)( _
              Arr As IEnumerable(Of TSrc), Converter As Converter(Of TSrc, TDest)) As List(Of TDest)
         Return (From itm In Arr Select Converter(itm)).ToList
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Sub Sort(Of T)(items() As T)
         Array.Sort(items)
      End Sub

#End Region 'Array

#Region "List(Of T)"

      <Extension()> _
      Public Sub SortX(Of T)(items As List(Of T), ParamArray getters() As Func(Of T, IComparable))
         Dim comparison As Comparison(Of T)
         Select Case getters.Length
            Case 0 : Throw items.Exception("cannot SortX with no getter defined")
            Case 1
               Dim gt = getters(0)
               comparison = Function(x As T, y As T) gt(x).CompareTo(gt(y))
            Case Else
               comparison = _
                  Function(x As T, y As T)
                     For Each gt In getters
                        Dim cmp = gt(x).CompareTo(gt(y))
                        If cmp <> 0 Then Return cmp
                     Next
                     Return 0
                  End Function
         End Select
         items.Sort(comparison)
      End Sub

      ''' <summary>lineare Suche in sortierter Liste (aufwärts oder abwärts), startend bei index. Schneller als BinarySearch, um bei nur teilweise assoziierten Listen die matchenden Elemente aufzufinden. Bei match ist der günstigste nächste start-index der match-index + 1. Bei nicht-match unverändert lassen</summary>
      <Extension(), Obsolete("better use BinarySearcher")> _
      Public Function TryFindLinearInSortedList(Of T, TKey As IComparable)(lst As IList(Of T), key As TKey, selector As Func(Of T, TKey), ByRef index As Integer) As Boolean
         Dim i = index
         If i >= lst.Count Then i = lst.Count - 1
         If i < 0 Then Return False
         Dim direction = key.CompareTo(selector(lst(i)))
         Select Case direction
            Case -1
               For i = index - 1 To 0 Step -1
                  Dim cmp = key.CompareTo(selector(lst(i)))
                  If direction <> cmp Then
                     If cmp = 0 Then index = i : Return True
                     Return False
                  End If
               Next
            Case 0 : Return True
            Case Else
               For i = index + 1 To lst.Count - 1
                  Dim cmp = key.CompareTo(selector(lst(i)))
                  If direction <> cmp Then
                     If cmp = 0 Then index = i : Return True
                     Return False
                  End If
               Next
         End Select
      End Function
      <Extension(), Obsolete("better use BinarySearcher")> _
      Public Function FindLinearInSortedList(Of T, TKey As IComparable)(lst As IList(Of T), key As TKey, selector As Func(Of T, TKey), start As Integer) As Integer
         If start < 0 Then Return -1
         Dim i = start
         Dim direction = key.CompareTo(selector(lst(i)))
         Select Case direction
            Case -1
               For i = start - 1 To 0 Step -1
                  Dim cmp = key.CompareTo(selector(lst(i)))
                  If direction <> cmp Then
                     If cmp = 0 Then Return i
                     Exit For
                  End If
               Next
               Return Not (i + 1)
            Case 0 : Return i
            Case Else
               For i = start + 1 To lst.Count - 1
                  Dim cmp = key.CompareTo(selector(lst(i)))
                  If direction <> cmp Then
                     If cmp = 0 Then Return i
                     Exit For
                  End If
               Next
               Return Not i
         End Select
      End Function

      <Extension()> _
      Public Sub InsertOrAdd(Of T)( _
            items As List(Of T), item As T, predicate As Predicate(Of T))
         items.InsertOrAdd(items.FindIndex(predicate), item)
      End Sub

      <Extension()> _
      Public Sub InsertOrAt0(Of T)( _
            items As List(Of T), item As T, predicate As Predicate(Of T))
         items.InsertOrAt0(items.FindIndex(predicate), item)
      End Sub

      ''' <summary>returnt die Einfügeposition des items in die asc-sortierte Liste </summary>
      <Extension()> _
      Public Function InsertPosition(Of T As IComparable)( _
            items As List(Of T), item As T) As Integer
         Dim i = items.BinarySearch(item)
         Return If(i < 0, Not i, i)
      End Function

#End Region 'List(Of T)

#Region "Dictionary(Of T, T2)"

      <Extension()> _
      Public Function GetOrCreate(Of Tkey, Tvalue As New)(subj As Dictionary(Of Tkey, Tvalue), key As Tkey) As Tvalue
         If Not subj.TryGetValue(key, GetOrCreate) Then
            GetOrCreate = New Tvalue
            subj.Add(key, GetOrCreate)
         End If
      End Function

      <Extension()> _
      Public Function GetOrDefault(Of Tkey, Tvalue)( _
            ByVal subj As Dictionary(Of Tkey, Tvalue), ByVal key As Tkey, Optional ByVal [default] As Tvalue = Nothing) As Tvalue
         If subj.TryGetValue(key, GetOrDefault) Then Exit Function
         Return [default]
      End Function

#End Region 'Dictionary(Of T, T2)

#Region "IList / IList(Of T)"

      <Extension(), DebuggerStepThrough()> _
      Public Sub ClearWith(Of T)(itms As IList(Of T), fill As T)
         For i = 0 To itms.Count - 1
            itms(i) = fill
         Next
      End Sub

      <Extension(), DebuggerStepThrough()> _
      Public Function Random(Of T)(itms As IList(Of T)) As T
         Dim cnt = itms.Count
         If cnt = 0 Then Throw New InvalidOperationException("the List does not contain elements")
         Return itms(_Rnc.Next(cnt))
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Sub Swap(items As IList, I1 As Integer, I2 As Integer)
         Dim Tmp = items(I1)
         items(I1) = items(I2)
         items(I2) = Tmp
      End Sub
      ''' <summary> Fisher-Yates-Mixing up the itms. On seed&lt;0 the random seed is used </summary>
      <Extension(), DebuggerStepThrough()> _
      Public Sub Shuffle(itms As IList, Optional seed As Integer = -1)
         If seed >= 0 Then _Rnc = New Random(seed)
         For i = itms.Count - 1 To 1 Step -1
            itms.Swap(i, _Rnc.Next(i + 1))
         Next
      End Sub

      <Extension(), DebuggerStepThrough()> _
      Public Sub Add(Of T)(items As ICollection(Of T), ParamArray itms() As T)
         For Each itm In itms : items.Add(itm) : Next
      End Sub

      <Extension()> _
      Public Function FirstDifference(Of T)(lists() As IList(Of T), selector As Func(Of T, Object)) As Integer
         Dim commonLength = Aggregate l In From lst In lists Select lst.Count Into Min()
         Dim ubound = lists.Count - 1
         For retVal = 0 To commonLength - 1
            Dim cmp = selector(lists(0)(retVal))
            For ii = 1 To ubound
               If Not selector(lists(ii)(retVal)).Equals(cmp) Then Return retVal
            Next
         Next
         Return commonLength
      End Function
      <Extension()> _
      Public Function FirstDifference(lists() As IList) As Integer
         Dim commonLength = Aggregate l In From lst In lists Select lst.Count Into Min()
         Dim ubound = lists.Length - 1
         For retVal = 0 To commonLength - 1
            Dim cmp = lists(0)(retVal)
            For ii = 1 To ubound
               If Not lists(ii)(retVal).Equals(cmp) Then Return retVal
            Next
         Next
         Return commonLength
      End Function

      <Extension()> _
      Public Function DifferenceAnalize(Of T1)(lst1 As IEnumerable(Of T1), lst2 As IEnumerable(Of T1), Optional keySelector As Func(Of T1, Integer) = Nothing) As DifferenceResult(Of T1, T1)
         Return DifferenceAnalize(lst1, lst2, keySelector, keySelector)
      End Function
      <Extension()> _
      Public Function DifferenceAnalize(Of T1, T2)(lst1 As IEnumerable(Of T1), lst2 As IEnumerable(Of T2), Optional keySelector1 As Func(Of T1, Integer) = Nothing, Optional keySelector2 As Func(Of T2, Integer) = Nothing, Optional skipDoubles As Boolean = False) As DifferenceResult(Of T1, T2)
         If keySelector1 Is Nothing Then keySelector1 = Function(o As T1) o.GetHashCode
         If keySelector2 Is Nothing Then keySelector2 = Function(o As T2) o.GetHashCode
         Dim dic1 = New Dictionary(Of Integer, T1)
         With DifferenceAnalize
            .List2_Only = New List(Of T2)
            .Mappings = New List(Of Tuple(Of T1, T2))
            Dim itm1 As T1 = Nothing
            For Each itm1 In lst1
               Try
                  dic1.Add(keySelector1(itm1), itm1)
               Catch ex As ArgumentException
                  If Not skipDoubles Then Throw New ArgumentException("all keyValues of lst1 must be unique")
               End Try
            Next
            Dim hsh = New HashSet(Of Integer)
            For Each itm2 In lst2
               Dim key = keySelector2(itm2)
               If Not hsh.Add(key) Then
                  If skipDoubles Then Continue For Else Throw New ArgumentException("all keyValues of lst2 must be unique")
               End If
               If dic1.TryGetValue(key, itm1) Then
                  .Mappings.Add(Tuple.Create(itm1, itm2))
                  dic1.Remove(key)
               Else
                  .List2_Only.Add(itm2)
               End If
            Next
            .List1_Only = dic1.Values.ToList
         End With
      End Function
      Public Structure DifferenceResult(Of T1, T2)
         Public List1_Only As List(Of T1)
         Public List2_Only As List(Of T2)
         Public Mappings As List(Of Tuple(Of T1, T2))
      End Structure

      <Extension()> _
      Public Sub InsertOrAdd(Of T)(items As IList(Of T), index As Integer, item As T)
         items.Insert(If(index < 0, items.Count, index), item)
      End Sub

      <Extension()> _
      Public Sub InsertOrAt0(Of T)(items As IList(Of T), index As Integer, item As T)
         items.Insert(If(index < 0, 0, index), item)
      End Sub

      <Extension(), DebuggerStepThrough()> _
      Public Function Clone(Of T As {IList, New})(items As T) As T
         Clone = New T
         For Each itm In items
            Clone.Add(itm)
         Next
      End Function

      ''' <summary>Bsp: vorletztes Element: list.Peek(-1)</summary>
      <Extension(), DebuggerStepThrough()> _
      Public Function Peek(Of T)(items As IList(Of T), Optional index As Integer = 0) As T
         Return items(index + items.Count - 1)
      End Function
      ''' <summary>Bsp: setze vorletztes Element: list.Poke(-1, "huhu")</summary>
      <Extension(), DebuggerStepThrough()> _
      Public Sub Poke(Of T)(items As IList(Of T), value As T, Optional index As Integer = 0)
         items(index + items.Count - 1) = value
      End Sub

      <Extension(), DebuggerStepThrough()> _
      Public Function Pop(Of T)(items As IList(Of T)) As T
         Dim i = items.Count - 1
         Pop = items(i)
         items.RemoveAt(i)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function PopAndPeek(Of T)(items As IList(Of T)) As T
         Dim i = items.Count - 1
         items.RemoveAt(i)
         Return items(i - 1)
      End Function

      ''' <summary>Refill oldValues with minimum occurances of CollectionChanged-Event</summary>
      ''' <param name="selectors">each selector extracts a significant Property from Item, to decide, whether two items are equal. multiple selectors consider multiple Properties</param>
      <Extension()> _
      Public Sub ReFillBy(Of T)(oldValues As IList(Of T), newValues As IEnumerable(Of T), ParamArray selectors() As Func(Of T, Object))
         Using ernt = newValues.GetEnumerator
            For i = 0 To oldValues.Count - 1
               If Not ernt.MoveNext Then ' newValues shorter than oldValues - then remove the oldValue-Rest
                  For ii = oldValues.Count - 1 To i Step -1
                     oldValues.RemoveAt(ii)
                  Next
                  Return
               End If
               Dim itm0 = oldValues(i)
               Dim itm1 = ernt.Current
               If Not (Object.Equals(itm0, itm1) OrElse (selectors.Length > 0 AndAlso selectors.All(Function(sel) Object.Equals(sel(itm0), sel(itm1))))) Then oldValues(i) = itm1
            Next
            While ernt.MoveNext : oldValues.Add(ernt.Current) : End While ' oldValues shorter than newValues - append the newValues-Rest
         End Using
      End Sub
      ''' <summary> remove all after index, then add newValues </summary>
      <Extension()> _
      Public Sub AddRangeAt(Of T)(items As IList(Of T), newValues As IEnumerable(Of T), Optional index As Integer = Integer.MaxValue)
         Using ernt = newValues.GetEnumerator
            For i = index To items.Count - 1
               If Not ernt.MoveNext Then
                  For ii = items.Count - 1 To i Step -1 : items.RemoveAt(ii) : Next
                  Return
               End If
               items(i) = ernt.Current
            Next
            While ernt.MoveNext : items.Add(ernt.Current) : End While
         End Using
      End Sub

      <Extension()> _
      Public Sub RemoveRangeX(items As IList, start As Integer, Optional count As Integer = Integer.MaxValue)
         count = Math.Min(count, items.Count - start)
         For i = start + count To items.Count - 1
            items(i - count) = items(i)
         Next
         For i = items.Count - 1 To items.Count - count Step -1
            items.RemoveAt(i)
         Next
      End Sub


#End Region 'IList

#Region "Enumerable"


      <Extension()> _
      Public Function SelectManyX(Of T)(items As IEnumerable(Of IEnumerable(Of T))) As IEnumerable(Of T)
         Return Linq.Enumerable.SelectMany(items, Function(itm) itm)
      End Function

      ''' <summary> combines elements to TResult, in order of occurance. Terminates at end of shortest list</summary>
      <Extension()> _
      Public Function Zip(Of T1, T2, T3, TResult)(lst1 As IEnumerable(Of T1), lst2 As IEnumerable(Of T2), lst3 As IEnumerable(Of T3), selector As Func(Of T1, T2, T3, TResult)) As List(Of TResult)
         Zip = New List(Of TResult)
         Using e1 = lst1.GetEnumerator, e2 = lst2.GetEnumerator, e3 = lst3.GetEnumerator
            While e1.MoveNext AndAlso e2.MoveNext AndAlso e3.MoveNext
               Zip.Add(selector(e1.Current, e2.Current, e3.Current))
            End While
         End Using
      End Function
      ''' <summary> combines elements to TResult, in order of occurance. Terminates at end of shorter list</summary>
      <Extension()> _
      Public Function Zip(Of T1, T2, TResult)(lst1 As IEnumerable(Of T1), selector As Func(Of T1, T2, TResult), lst2 As IEnumerable(Of T2)) As List(Of TResult)
         Zip = New List(Of TResult)
         Using e1 = lst1.GetEnumerator, e2 = lst2.GetEnumerator
            While e1.MoveNext AndAlso e2.MoveNext
               Zip.Add(selector(e1.Current, e2.Current))
            End While
         End Using
      End Function
      ''' <summary> combines elements to Tuples(of T1, T2), in order of occurance. Terminates at end of shorter list</summary>
      <Extension()> _
      Public Function Zip(Of T1, T2)(lst1 As IEnumerable(Of T1), lst2 As IEnumerable(Of T2)) As List(Of Tuple(Of T1, T2))
         Return lst1.Zip(AddressOf Tuple.Create, lst2)
         Return lst1.Zip(lst2, AddressOf Tuple.Create).ToList
      End Function

      ''' <summary> drops one element from list</summary>
      <Extension()> _
      Public Function ExceptAt(Of T)(items As IEnumerable(Of T), index As Integer) As List(Of T)
         ExceptAt = New List(Of T)
         With items.GetEnumerator
            If index >= 0 Then
               For i = 0 To index - 1
                  If Not .MoveNext Then Exit Function
                  ExceptAt.Add(.Current)
               Next
               If Not .MoveNext Then Exit Function
            End If
            While .MoveNext : ExceptAt.Add(.Current) : End While
            .Dispose()
         End With
      End Function

      Public Structure MinMax(Of T, T2 As IComparable)
         Public Min, Max As T
         Public MinVal, MaxVal As T2
         Private _Selector As Func(Of T, T2)
         Public ReadOnly HasValue As Boolean
         Public Sub New(ByVal first As T, ByVal selector As Func(Of T, T2))
            _Selector = selector
            Me.Min = first : Me.Max = first
            MinVal = _Selector(first) : MaxVal = MinVal
            HasValue = True
         End Sub
         Public Sub Check(ByVal itm As T)
            Dim val = _Selector(itm)
            If val.CompareTo(MinVal) < 0 Then
               Min = itm
               MinVal = val
            ElseIf val.CompareTo(MaxVal) > 0 Then
               Max = itm
               MaxVal = val
            End If
         End Sub
      End Structure
      <Extension()> _
      Public Function Extremum(Of T, T2 As IComparable)(ByVal items As IEnumerable(Of T), ByVal selector As Func(Of T, T2)) As MinMax(Of T, T2)
         With items.GetEnumerator
            If Not .MoveNext Then .Dispose() : Return Nothing
            Extremum = New MinMax(Of T, T2)(.Current, selector)
            While .MoveNext : Extremum.Check(.Current) : End While
            .Dispose()
         End With
      End Function
      Private Function ExtremumStrict(Of T, T2 As IComparable)(ByVal items As IEnumerable(Of T), ByVal selector As Func(Of T, T2)) As MinMax(Of T, T2)
         ExtremumStrict = items.Extremum(selector)
         If Not ExtremumStrict.HasValue Then Throw New InvalidOperationException("the collection does not contain elements")
      End Function
      <Extension()> Public Function MaxBy(Of T, T2 As IComparable)(ByVal items As IEnumerable(Of T), ByVal selector As Func(Of T, T2)) As T
         Return ExtremumStrict(items, selector).Max
      End Function
      <Extension()> _
      Public Function MinBy(Of T, T2 As IComparable)(ByVal items As IEnumerable(Of T), ByVal selector As Func(Of T, T2)) As T
         Return ExtremumStrict(items, selector).Min
      End Function


      <Extension()> _
      Public Function AllChilds(Of T)( _
            GetChilds As Func(Of T, IEnumerable), _
            Roots As IEnumerable) As IEnumerable(Of T)
         Dim Enumerate As Func(Of IEnumerable(Of T), IEnumerable(Of T)) = Nothing
         Enumerate = Function(enmbl) enmbl.Concat(enmbl.SelectMany(Function(nd) Enumerate(GetChilds(nd).Cast(Of T))))
         Return Enumerate(Roots.Cast(Of T))
      End Function

      <Extension()> _
      Public Function All(Of T)( _
            GetChilds As Func(Of T, IEnumerable), Root As T) As IEnumerable(Of T)
         'Root wird in die Enumeration hineingenommen, indem ein es enthaltendes IEnumerable(Of T) 
         'geschaffen wird, dessen Kinder ( = nur Root ) rekursiv enumeriert werden
         Return GetChilds.AllChilds(New T() {Root})
      End Function

      <Extension()> _
      Public Function AllAsList(Of T)(getChilds As GetChilds(Of T), Roots As IEnumerable) As List(Of T)
         Dim ret As New List(Of T)
         For Each child As T In Roots : ret.Add(child) : Next
         Dim i As Integer = 0
         While i < ret.Count
            For Each child As T In getChilds(ret(i)) : ret.Add(child) : Next
            i += 1
         End While
         Return ret
      End Function

      <Extension()> _
      Public Function AllAsList(Of T)(getChilds As GetChilds(Of T), Root As T) As List(Of T)
         Return getChilds.AllAsList(New T() {Root})
      End Function

      <Extension()> _
      Public Function DisposeAll(Of T As IDisposable)(items As IList(Of T)) As IList(Of T)
         For Each itm As T In items
            If itm IsNot Nothing Then itm.Dispose()
         Next
         If Not items.IsReadOnly Then items.Clear()
         Return items
      End Function

      <Extension()> _
      Public Sub DisposeAll(Of T As IDisposable)(items As IEnumerable(Of T))
         For Each itm As T In items
            If itm IsNot Nothing Then itm.Dispose()
         Next
      End Sub

      <Extension()> _
      Public Function IndexOf(Of TItem, TKey)(items As IList(Of TItem), selector As Func(Of TItem, TKey), key As TKey, Optional start As Integer = 0) As Integer
         For IndexOf = start To items.Count - 1
            If Object.Equals(selector(items(IndexOf)), key) Then Exit Function
         Next
         Return -1
      End Function
      <Extension(), DebuggerStepThrough> _
      Public Function FindIndex(Of T)(items As IList(Of T), predicate As Func(Of T, Boolean), Optional start As Integer = 0) As Integer
         For FindIndex = start To items.Count - 1
            If predicate(items(FindIndex)) Then Exit Function
         Next
         Return -1
      End Function

      <Extension()> _
      Public Function FindIndex(Of T)(items As IList, predicate As Func(Of T, Boolean), Optional start As Integer = 0) As Integer
         For FindIndex = start To items.Count - 1
            If predicate(DirectCast(items(FindIndex), T)) Then Exit Function
         Next
         Return -1
      End Function

      <Extension(), DebuggerStepThrough> _
      Public Sub ForEach(Of T)(items As IEnumerable(Of T), Action As Action(Of T))
         For Each itm In items : Action(itm) : Next
      End Sub
      <Extension()> _
      Public Sub ForEach(Of T)(items As IEnumerable(Of T), Action As Action(Of Integer, T), Optional start As Integer = 0)
         For Each itm In items
            Action(start, itm)
            start += 1
         Next
      End Sub

      <Extension()> _
      Public Function Take(Of T)(items As IEnumerable(Of T), start As Integer, count As Integer) As IEnumerable(Of T)
         Return items.Skip(start).Take(count)
      End Function
      ''' <summary> removes all occurances of item </summary>
      <Extension()> _
      Public Function Except(Of T)(items As IEnumerable(Of T), item As T) As IEnumerable(Of T)
         Return items.Except(New T() {item})
      End Function

      <Extension()> _
      Public Function ToArray(Of T, T2)(items As IEnumerable(Of T), selector As Func(Of T, T2)) As T2()
         Return items.Select(selector).ToArray()
      End Function
      <Extension()> _
      Public Function ToList(Of T, T2)(items As IEnumerable(Of T), selector As Func(Of T, T2)) As List(Of T2)
         Return items.Select(selector).ToList()
      End Function
      <Extension()> _
      Public Function ToListFiltered(Of T)(items As IEnumerable(Of T), filter As Func(Of T, Boolean)) As List(Of T)
         Return items.Where(filter).ToList()
      End Function
      <Extension()> _
      Public Function ToList(Of T)(items As IEnumerable(Of T), other As IEnumerable(Of T), ParamArray more() As IEnumerable(Of T)) As List(Of T)
         Dim src(1 + more.Length) As IEnumerable(Of T)
         src(0) = items
         src(1) = other
         Array.Copy(more, 0, src, 2, more.Length)
         Return src.SelectMany(Nops(Of IEnumerable(Of T)).Echo).ToList()
      End Function

#End Region 'Enumerable

   End Module

End Namespace
