﻿Imports System.Runtime.InteropServices

Namespace System
   Public Delegate Function Func(Of Ta, Tb, Tc, Td, Te, TResult)(a As Ta, b As Tb, c As Tc, d As Td, e As Te) As TResult

   Public Class WithoutEvents
      Public Shared Function Create(Of T As Class)(ByRef itm As T) As T
         Create = itm
         itm = Nothing
      End Function
   End Class
   ''' <summary>can be used as optional parameter </summary>
   ''' <remarks>in 2010 no longer needed</remarks>
   Public Class Nullable2(Of T As Structure)
      Public Value As T
      Public Shared Widening Operator CType(other As T) As Nullable2(Of T)
         Return New Nullable2(Of T) With {.Value = other}
      End Operator
   End Class



   <StructLayout(LayoutKind.Explicit)> _
   Public Structure NumbConverter
      <FieldOffset(0)> Public Byte0 As Byte
      <FieldOffset(1)> Public Byte1 As Byte
      <FieldOffset(2)> Public Byte2 As Byte
      <FieldOffset(3)> Public Byte3 As Byte
      <FieldOffset(4)> Public Byte4 As Byte
      <FieldOffset(5)> Public Byte5 As Byte
      <FieldOffset(6)> Public Byte6 As Byte
      <FieldOffset(7)> Public Byte7 As Byte
      <FieldOffset(0)> Public Int16_0 As Int16
      <FieldOffset(2)> Public Int16_1 As Int16
      <FieldOffset(4)> Public Int16_2 As Int16
      <FieldOffset(6)> Public Int16_3 As Int16
      <FieldOffset(0)> Public Char_0 As Char
      <FieldOffset(2)> Public Char_1 As Char
      <FieldOffset(4)> Public Char_2 As Char
      <FieldOffset(6)> Public Char_3 As Char
      <FieldOffset(0)> Public Int32_0 As Int32
      <FieldOffset(4)> Public Int32_1 As Int32
      <FieldOffset(0)> Public Single0 As Single
      <FieldOffset(4)> Public Single1 As Single
      <FieldOffset(0)> Public [Int64] As Int64
      <FieldOffset(0)> Public [Double] As Double
      <FieldOffset(0)> Public DateTime As DateTime
      <FieldOffset(0)> Public Timespan As TimeSpan
      Private Shared _Instance As NumbConverter
      Public Function Bytes() As Byte()
         Dim arr(7) As Byte
         Buffer.BlockCopy({Int64}, 0, arr, 0, 8)
         Return arr
      End Function

      Public Function Array(Of T)() As T()
         Dim sz = Marshal.SizeOf(GetType(T))
         Dim length = 8 \ sz
         Dim arr(length - 1) As T
         Buffer.BlockCopy({Int64}, 0, arr, 0, 8)
         Return arr
      End Function

      Public Shared Function Array(Of T)(value As T(), elementSize As Integer) As NumbConverter
         Return _Instance.SetArray(value, value.Length * elementSize)
      End Function
      Public Shared Function Bytes(value As Byte()) As NumbConverter
         Return _Instance.SetArray(value, value.Length)
      End Function
      Public Shared Function Shorts(value As Int16()) As NumbConverter
         Return _Instance.SetArray(value, value.Length << 1)
      End Function
      Public Shared Function Integers(value As Int32()) As NumbConverter
         Return _Instance.SetArray(value, value.Length << 2)
      End Function
      Private Function SetArray(arr As Array, byteLength As Integer) As NumbConverter
         Dim _Longs(0) As Int64
         Buffer.BlockCopy(arr, 0, _Longs, 0, Math.Min(byteLength, 8))
         [Int64] = _Longs(0)
         Return Me
      End Function
   End Structure

   Public Class MyStopWatch
      'Use: enclose what you want to benchmark in a While MyStopWatch.Until() - loop. It will display, how
      '! often the enclosed stuff was executed
      Private Sub UntilDemo()
         While MyStopWatch.Until(1000, "Demo")
            Console.WriteLine("Demo, Text" & Date.Now)
         End While
      End Sub

      Private Shared _Counter As Integer
      Private Shared _LastTick As Integer = Integer.MinValue

      Public Shared Function Until( _
            RunTime As Integer, Optional Msg As String = "MyStopWatch") As Boolean
         If Environment.TickCount < _LastTick Then
            _Counter += 1
         ElseIf _LastTick = Integer.MinValue Then
            _LastTick = Environment.TickCount + RunTime
            _Counter = 0
         Else
            Console.WriteLine(String.Format("{0,15}: {1,10}", Msg, _Counter))
            _LastTick = Integer.MinValue
            Return False
         End If
         Return True
      End Function

   End Class

   Public Class Counter
      Public Value As Integer = 0

      ''' <summary> gibt den aktuellen Wert zurück und incrementiert anschließend </summary>
      <DebuggerStepThrough()> _
      Public Function Up(Optional stp As Integer = 1) As Integer
         Up = Value
         Value += stp
      End Function

      ''' <summary> gibt den aktuellen Wert zurück und decrementiert anschließend </summary>
      <DebuggerStepThrough()> _
      Public Function Down() As Integer
         Return Up(-1)
      End Function
      ''' <summary>Decrementiert und returnt beim 0-Durchgang True</summary>
      <DebuggerStepThrough()> _
      Public Function Fallback() As Boolean
         Return Up(-1) = 0
      End Function
      ''' <summary>Decrementiert oder returnt False, wann 0 unterschritten würde</summary>
      <DebuggerStepThrough()> _
      Public Function TryFallback() As Boolean
         If Value < 1 Then Return False
         Value -= 1
         Return True
      End Function
      <DebuggerStepThrough()> _
      Public Shared Widening Operator CType(i As Integer) As Counter
         Return New Counter() With {.Value = i}
      End Operator
      <DebuggerStepThrough()> _
      Public Shared Widening Operator CType(i As Counter) As Integer
         Return i.Value
      End Operator
      <DebuggerStepThrough()> _
      Public Shared Operator &(left As String, right As Counter) As String
         Return right.Value.ToString
      End Operator
      <DebuggerStepThrough()> _
      Public Overrides Function ToString() As String
         Return Value.ToString()
      End Function
   End Class

End Namespace