﻿#Region "FileHeader"
#If False Then
Hiermit kann man Viewmodel-Objekte draggen, die ihre Visuals über eine gebundene Point-Property steuern. Datentyp und Name des Viewmodels ist beim Erstellen anzugeben, und im weiteren auch ein Control, dessen MouseMoves zu überwachen sind. Das Control muss natürlich die Visuals enthalten - es kann etwa eine Listbox sein, mit einem Canvas als ItemPanel oder dgl.
Die Property wird dann per PropertyDescriptor gelesen/beschrieben.
Ist bischen Schmuddel, dass diese Klasse im VM instanziert wird, und sich das Control holen muss.
Man könnte auch ein Behavior schreiben, was per Konvention eine "Location"-Property im Viewmodel vorraussetzt. Dann müsste man halt ohne die Events auskommen, denn die machen ja nur im Viewmodel Sinn.
Ursprünglich wollte ich hier auch Hovern behandeln, aber das kann man besser (und VM-unabhängig) mit einem Style-Trigger, der IsMouseOver überwacht.
#End If '-- Options, Imports
#End Region 'FileHeader


Imports System.ComponentModel

Public Class DragManager(Of TVM As Class)
   Public Event DragStart As EventHandler
   Public Event Dragging As EventHandler
   Public Event DragEnd As EventHandler

   Public WithEvents Ctl As Control
   Private _Descr As PropertyDescriptor
   Private _DragOffs As Vector
   Private _Dragged As TVM
   Public ReadOnly Property Dragged As TVM
      Get
         Return _Dragged
      End Get
   End Property

   Public Sub New(pointPropertyName As String)
      Dim props = TypeDescriptor.GetProperties(GetType(TVM))
      _Descr = props(pointPropertyName)
   End Sub

   Private Sub Listbox_MouseLeftButtonUp(sender As Object, e As MouseButtonEventArgs)
      RemoveHandler Ctl.MouseMove, AddressOf Listbox_MouseMove
      RemoveHandler Ctl.MouseLeftButtonUp, AddressOf Listbox_MouseLeftButtonUp
      RaiseEvent DragEnd(Me, EventArgs.Empty)
   End Sub

   Private Sub Listbox_MouseMove(sender As Object, e As MouseEventArgs)
      _Descr.SetValue(_Dragged, e.GetPosition(Ctl) - _DragOffs)
      RaiseEvent Dragging(Me, EventArgs.Empty)
   End Sub

   Private Sub Listbox_PreviewMouseLeftButtonDown(sender As Object, e As MouseButtonEventArgs) Handles Ctl.PreviewMouseLeftButtonDown
      _Dragged = e.FindParentContext(Of TVM)()
      If _Dragged.Null Then Return
      AddHandler Ctl.MouseMove, AddressOf Listbox_MouseMove
      AddHandler Ctl.MouseLeftButtonUp, AddressOf Listbox_MouseLeftButtonUp
      Dim pt = DirectCast(_Descr.GetValue(_Dragged), Point)
      _DragOffs = e.GetPosition(Ctl) - pt
      RaiseEvent DragStart(Me, EventArgs.Empty)
   End Sub
End Class
