﻿Imports System.ComponentModel
Imports System.Windows.Media

Public Class ArcSegmentVM : Inherits NotifyPropertyChanged

   Public Property Size As New Size(200, 100)

   Public Sub New()
      Update()
   End Sub

   Private _X As Double = 30
   Public Property X() As Double
      Get
         Return _X
      End Get
      Set(ByVal value As Double)
         ChangePropIfDifferent(value, _X, AddressOf Update, "X", "Point", "Points")
      End Set
   End Property
   Private _Y As Double = 30
   Public Property Y() As Double
      Get
         Return _Y
      End Get
      Set(ByVal value As Double)
         ChangePropIfDifferent(value, _Y, AddressOf Update, "Y", "Point", "Points")
      End Set
   End Property
   'pt0, pt1, mitte, tg0, tg1
   Private _Points(4) As Point
   Public ReadOnly Property Points() As Point()
      Get
         Return _Points
      End Get
   End Property

   Public ReadOnly Property Point() As Point
      Get
         Return New Point(_X, _Y)
      End Get
   End Property


   Private Sub Update()
      Dim mtr = New Matrix
      Dim mtrCumul As New Matrix
      _Points(0) = New Point(0, 0)           ' Startpunkt
      _Points(1) = Point                     ' Zielpunkt
      mtr.Scale(1, Size.Width / Size.Height) ' auf Kreis projezieren
      Transform(mtrCumul, mtr)
      Dim alpha = Math.Atan2(_Points(1).Y, _Points(1).X) * 180 / Math.PI 'Winkel der Sekante zur X-Achse
      mtr.Rotate(-alpha)                     ' um Startpunkt drehen, dass Zielpunkt auch auf X-Achse 
      Transform(mtrCumul, mtr)
      Dim x = _Points(1).X / 2
      Dim ptm = New Point(x, -Math.Sqrt(Size.Width * Size.Width - x * x)) ' Mittelpunkt-Höhe mit Pythagoras
      Points(2) = ptm
      alpha = 90 + Math.Atan2(ptm.Y, ptm.X) * 180 / Math.PI             'Winkel Mitte/Startpunkt
      mtr.Rotate(-alpha)                                       'Mitte senkrecht über Startpunkt drehen
      Transform(mtrCumul, mtr)
      _Points(3) = New Point(-150, 0)                       ' TangentenPunkt1 auf der X-Achse eintragen
      mtr.RotateAt(2 * alpha, _Points(2).X, _Points(2).Y)  'um Mittelpunkt drehen, dass Mitte über Zielpunkt steht
      Transform(mtrCumul, mtr)
      _Points(4) = New Point(150, 0)            ' ziel-TangentenPunkt eintragen
      mtrCumul.Invert()
      mtrCumul.Transform(Points)      ' alle kumulierten Transformationen rückgängig machen - dasses wieder die ellipse wird
   End Sub

   Private Sub Transform(ByRef mtrCumul As Matrix, ByRef mtr As Matrix)
      mtrCumul *= mtr
      mtr.Transform(_Points)
      mtr.SetIdentity()
   End Sub


End Class
