﻿Imports System.ComponentModel
Imports System.Windows.Media
Imports System.Collections.ObjectModel
Imports System.Text.RegularExpressions
Imports System.Globalization

Public Class DragablePath : Inherits NotifyPropertyChanged

   Private WithEvents _DragManager As New DragManager(Of DragPoint)("Point")

   Public Property LstSubscribe As Action(Of Object) = Sub(o) _DragManager.Ctl.Be(o)
#If True Then
#ElseIf True Then
   dieses komische vermeidet Initiale Binding-Fehler beim Startup
   Public Property LstSubscribe As Action(Of Object) = Sub(o)
                                                          System.Threading.Thread.Sleep(1000)
                                                          _DragManager.Ctl.Be(o)
                                                       End Sub
#ElseIf True Then
#End If


   Public Property PathGeometry As New PathGeometry
   Private WithEvents __DraggablePoints As New ObservableCollection(Of DragPoint)
   Public WithEvents DraggablePoints As New ListCollectionView(__DraggablePoints) With {.NewItemPlaceholderPosition = NewItemPlaceholderPosition.None}

   Public Property cmdApplyData As New RelayCommand(AddressOf ApplyPathData)

   Public Property cmdShowReadme As New RelayCommand(AddressOf ShowReadme)

   Public Sub New()
      If NotifyPropertyChanged.IsInDesignMode Then
         'Return
      End If
      ApplyPathData()
   End Sub
   Private Sub ApplyPathData()
      Try
         PathGeometry.Figures = PathDataConverter.GetPathFigureCollection(_SmartFormatted)
      Catch ex As Exception
         Msg(ex.GetType.Name, Lf, ex.Message)
         Return
      End Try
      Dim PathFigureWrappers = PathGeometry.Figures.Select(Function(fg) New PathFigureWrapper(fg))
      __DraggablePoints.ReFillBy(PathFigureWrappers.SelectMany(Function(pfwr) pfwr.GetDragPoints))
      PathDataConverter.GetDataStrings(PathGeometry.Figures, RawFormatted, SmartFormatted)
   End Sub

   Private _SmartFormatted As String = "M10,40 l50,-20 50,50 M144,40 l 45,45 M270,50 a75,25,45,1,0, 45,44 a75,25,45,1,1, 81,34 q44,-70 80,3 M 20,300 c10,-150 40,100 92,31 52,-69 28,59 78,9"
   Public Property SmartFormatted() As String
      Get
         Return _SmartFormatted
      End Get
      Set(ByVal value As String)
         ChangePropIfDifferent(value, _SmartFormatted)
      End Set
   End Property

   Private _RawFormatted As String
   Public Property RawFormatted() As String
      Get
         Return _RawFormatted
      End Get
      Private Set(ByVal value As String)
         ChangePropIfDifferent(value, _RawFormatted)
      End Set
   End Property

   Private Sub _DragManager_Dragging(sender As Object, e As EventArgs) Handles _DragManager.Dragging
      PathDataConverter.GetDataStrings(PathGeometry.Figures, RawFormatted, SmartFormatted)
   End Sub

   Private Sub ShowReadme()
      Dim msgs = {
         "'Raw Syntax' zeigt die String-Repräsentation des gezeigten Paths, wie sie der TypeConverter generiert:",
         "Alles in eine Zeile, und Punkt-Angaben in absoluten Koordinaten.",
         "Ausserdem generiert der TypConverter keine verkürzten Syntax-Elemente, wie S (smoothe Bezier) oder H / V (horizontal/vertical Line).",
         "",
         "'Smart Syntax' ist eine leichter lesbare Umarbeitung der Raw Syntax.",
         "Kann auch editiert werden, und der Apply-Button wendet die Eingabe dann an.",
         "Dabei funktioniert jede gültige Syntax, aber bei Anwendung wird die Eingabe ersetzt durch die Standard-Darstellung, wie sie sich aus Umarbeitung der Raw-Syntax ergibt.",
         "Sodass ggfs. verwendete absolute Koordinaten, verkürzte Syntax-Elemente, oder anderes Layout dann wieder futsch sind.",
         "",
         "Insbesondere für 'a' (Ellipse-Segment) ist händische Eingabe erforderlich, denn die Maus kann nur Start- und Ziel-Punkt bewegen - nicht die anderen Parameter: x/y-Radius, Rotation, largeArc, clockwise.",
         "",
         "Zur Syntax siehe auch den Reiter 'Commented Samples' oder das Readme im Code."}
      MessageBox.Show(Lf.Between(msgs), "Explaination")
   End Sub

End Class
