﻿Namespace System.Windows.Controls

   ''' <summary>
   ''' compares the bound value to the parameter. You can specify True/False-Values. If so, you can omit passing parameter - instead bind to a bool property
   ''' </summary>
   <System.Windows.Markup.ContentProperty("Values")>
   Public Class BoolConverter : Implements IValueConverter
      ''' <summary>
      ''' The first is the True-Value. False-Value is optional. More Values will be ignored
      ''' </summary>
      Public Property Values As New List(Of Object)

      Private Function _Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As Globalization.CultureInfo) As Object Implements IValueConverter.Convert
         Dim val = False
         If parameter IsNot Nothing Then
            val = Convert.ToString(value) = parameter.ToString()
         ElseIf TypeOf value Is Boolean Then
            val = DirectCast(value, Boolean)
         End If
         If Values.Count = 0 Then Return val
         If val Then Return Values(0)
         Return If(Values.Count > 1, Values(1), Nothing)
      End Function
      Private Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack
         Return Values(0).Equals(value)
      End Function

   End Class

End Namespace
