﻿Imports System.Collections.Generic

Namespace System.Windows.Controls

   <System.Windows.Markup.ContentProperty("Columns")> _
   Public Class MultiplyConverter : Implements IValueConverter

      Private _RoundOption As MidpointRounding = MidpointRounding.AwayFromZero

      Public Property RoundToEven As Boolean
         Get
            Return _RoundOption = MidpointRounding.ToEven
         End Get
         Set(ByVal value As Boolean)
            _RoundOption = If(value, MidpointRounding.ToEven, MidpointRounding.AwayFromZero)
         End Set
      End Property

      Public Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal param As Object, _
            ByVal culture As Globalization.CultureInfo) As Object Implements Data.IValueConverter.Convert
         If TypeOf value Is String Then value = Double.Parse(value.ToString, culture)
         Dim d = Double.Parse(param.ToString, culture) * CType(value, Double)
         If targetType.Equals(GetType(Double)) Then Return d
         If targetType.Equals(GetType(Single)) Then Return CType(d, Single)
         If targetType.Equals(GetType(Integer)) Then Return CType(Math.Round(d, _RoundOption), Integer)
         If targetType.Equals(GetType(String)) Then Return d.ToString(culture)
         If targetType.Equals(GetType(Decimal)) Then Return Decimal.Parse(param.ToString(), culture) * CType(value, Decimal)
         Throw Me.Exception("targetType '".And(targetType.Name, "' is not supported"))
      End Function

      Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal param As Object, _
            ByVal culture As Globalization.CultureInfo) As Object Implements Data.IValueConverter.ConvertBack
         Throw New NotSupportedException
      End Function
   End Class

End Namespace
