﻿#Region "FileHeader"
#If False Then
Mainly provides Informations about the Data of an ItemsControl-Item: 1) ItemContainer: the Control under the mouse, 2) Item: its DataContext, 3) ItemsSource: the ItemsSource-Porperty of the ItemsControls which contains ItemContainer, 4) Index: Index of Item in IntemsSource
The other stuff is additional
#End If
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Media
Imports System.Windows.Controls
#End Region 'FileHeader
Namespace System.Windows.Controls

   Public Class ItemInfo : Implements IEquatable(Of ItemInfo)

      Public Index As Integer = -1
      ''' <summary> the Data-Item. Causes Error in DropStyle.Insert-context</summary>
      Public ReadOnly Property Item As Object
         Get
            If _Item Is Nothing Then Throw New InvalidOperationException("This ItemInfo intends DropStyle.Insert - therefor a (DropOn-target-)Item is not provided")
            Return _Item
         End Get
      End Property
      Friend _Item As Object
      ''' <summary> the Frameworkelement, which presents the Data-Item</summary>
      Public ItemContainer As FrameworkElement
      ''' <summary> the collection, which contains the Data-Item</summary>
      Public ItemsSource As IEnumerable
      Public Sub InsertRange(values As IEnumerable)
         Dim lst = GetItemsSourceAsIList()
         For Each value In values
            lst.Insert(Index, value)
            Index += 1
         Next
      End Sub
      Public Sub Insert(value As Object)
         GetItemsSourceAsIList().Insert(Index, value)
      End Sub
      Public Sub RemoveItem()
         GetItemsSourceAsIList().RemoveAt(Index)
      End Sub
      ''' <summary> retrieves the perhaps wrapped ItemsSource-Source, which hopefully is IList - otherwise InvalidOperationException </summary>
      Public Function GetItemsSourceAsIList() As IList
         Dim src = ItemsSource
         Do
            Dim res = TryCast(src, IList)
            If res.NotNull Then Return res
            Dim cv = TryCast(src, ICollectionView)
            If cv.Null Then Throw New InvalidOperationException("cannot provide ItemsSource as IList")
            src = cv.SourceCollection
         Loop
      End Function

      Public Overloads Function Equals(other As ItemInfo) As Boolean Implements IEquatable(Of ItemInfo).Equals
         Return other.NotNull AndAlso GetHashCode() = other.GetHashCode
      End Function
      Public Overrides Function Equals(obj As Object) As Boolean
         Return Equals(TryCast(obj, ItemInfo))
      End Function
      Public Overrides Function GetHashCode() As Integer
         Return Index Xor ItemsSource.GetHashCode
      End Function
      Public Overrides Function ToString() As String
         If _Item Is Nothing Then Return "Insert at: " & Index
         Return String.Concat("Drop on: ", _Item, " (at: ", Index, ")")
      End Function

      ''' <summary> bubble up from e.OriginalSource to e.Source and select ItemInfos from perhaps nested ItemContainers </summary>
      Public Shared Function GetItemInfos(e As RoutedEventArgs) As ItemInfo()
         Dim stk As New Stack(Of ItemInfo)(10)
         Dim goal = e.Source
         If Not TypeOf goal Is ItemsControl Then Throw New ArgumentException("e.Source must be ItemsControl")
         If goal Is e.OriginalSource Then Return {}
         Dim parent = DirectCast(e.OriginalSource, DependencyObject)
         Do
            Dim dc = DirectCast(parent, FrameworkElement).DataContext
            Dim inf = New ItemInfo With {._Item = dc}
            Dim ic As DependencyObject
            Do
               ic = parent
               parent = VisualTreeHelper.GetParent(parent)
               If parent Is goal Then Return New ItemInfo() {}
            Loop Until DirectCast(parent, FrameworkElement).DataContext IsNot dc
            inf.ItemContainer = DirectCast(ic, FrameworkElement)
            Do
               parent = VisualTreeHelper.GetParent(parent)
            Loop Until TypeOf parent Is ItemsControl
            Dim itemsControl = DirectCast(parent, ItemsControl)
            inf.ItemsSource = itemsControl.ItemsSource
            inf.Index = itemsControl.ItemContainerGenerator.IndexFromContainer(inf.ItemContainer)
            stk.Push(inf)
         Loop Until parent Is goal
         Return stk.ToArray
      End Function


   End Class

End Namespace
