﻿Imports System.Collections.ObjectModel
Imports System.Collections.Specialized

Namespace System.Windows.Controls

   <System.Windows.Markup.ContentProperty("Templates")>
   Public Class KeyTemplateSelector : Inherits DataTemplateSelector

      Private Shared _errorTemplate As New DataTemplate

      Shared Sub New()
         With New FrameworkElementFactory(GetType(TextBlock))
            .SetValue(TextBlock.TextProperty, "errorTemplate")
            _errorTemplate.VisualTree = .Self
         End With
      End Sub

      Public Property Templates() As New List(Of DataTemplate)

      Private _Keys As New List(Of Object)
      Public ReadOnly Property Keys() As List(Of Object)
         Get
            Return _Keys
         End Get
      End Property

      Private _Resolver As New System.Reflection.PropertyPathResolver
      Public Property PropertyPath() As String
         Get
            Return _Resolver.PropertyPath
         End Get
         Set(ByVal NewValue As String)
            _Resolver.PropertyPath = NewValue
         End Set
      End Property

      Public Overrides Function SelectTemplate(ByVal item As Object, ByVal container As DependencyObject) As DataTemplate
         Dim indx = _Keys.IndexOf(_Resolver.GetValueFrom(item))
         If indx < 0 Then indx = _Keys.Count
         Return If(indx >= Templates.Count, _errorTemplate, _Templates(indx))
      End Function

   End Class

End Namespace
